package ssw.mj;

import java.io.Reader;

/**
 * The Scanner for the MicroJava Compiler.
 */
public class Scanner {
	private static final char EOF = (char) -1;
	private static final char CR = '\r';
	private static final char LF = '\n';

	/** Input data to read from. */
	private static Reader in;

	/** Lookahead character. (= next (unhandled) character in the input stream) */
	private static char ch;

	/** Current line in input stream. */
	private static int line;

	/** Current column in input stream. */
	private static int col;
	
	
	/** 
	 * Adds error message to the list of errors.
	 */
	private static void error(Token t, String msgKey, Object... msgParams) {
		Errors.error(t.line, t.col, msgKey, msgParams);
		
		// reset token content (consistent JUnit tests) 
		t.val = 0;
		t.str = null;
	}
	
	
	// TODO Exercise 2: implementation of scanner
	
	
	/** 
	 * Initializes the scanner. 
	 */
	public static void init(Reader r) {
		// initialize error handling support
		Errors.init();
	}

	/** 
	 * Returns next token.
	 * To be used by parser.
	 */
	public static Token next() {
		return new Token(Token.eof, 1, 1);
	}
}
