package ssw.mj.symtab;

/**
 * MicroJava Symbol Table Scopes
 * 
 * @author AW
 */
public class Scope {
	public Scope outer; // reference to enclosing scope
	public Obj locals;  // symbol table of this scope
	public int nVars;   // # of variables in this scope

	
	/**
	 * String representation for JUnit test cases.
	 */
	public void dump(StringBuilder sb) {
		sb.append("-- begin scope (");
		sb.append(nVars);
		sb.append(" variables) --\n");
		locals.dump(sb, "", false, true);

		if (outer != null) {
			outer.dump(sb);
		}
	}
}
